<?php
/*
Plugin Name: XML-RPC Disable (By EasyToolsWP)
Description: Make it possible to disable XML-RPC functionality for a more secure platform
Version: 1.3
Author: EasyToolsWP.com
*/

// Add subpage to WP Tools menu
add_action('admin_menu', 'mysmart_xmlrpc_manager_menu');

function mysmart_xmlrpc_manager_menu() {
    add_submenu_page(
        '',
        'EasyToolsWP XML-RPC Manager',
        'XML-RPC Manager',
        'manage_options',
        'easytoolswp_pro-settings',
        'mysmart_xmlrpc_manager_settings_page'
    );
}

// Callback function to display the settings page
function mysmart_xmlrpc_manager_settings_page() {
    if ($_SERVER["REQUEST_METHOD"] == "POST") {
        $enabled = isset($_POST['xmlrpc_manager_enabled']) && $_POST['xmlrpc_manager_enabled'] === '1';
        update_option('xmlrpc_manager_enabled', $enabled);

        // Enable or disable XML-RPC based on user's choice
        if ($enabled) {
            add_filter('xmlrpc_enabled', '__return_true');
        } else {
            add_filter('xmlrpc_enabled', '__return_false');
            remove_action('wp_head', 'rsd_link');
        }
    }

    $enabled = get_option('xmlrpc_manager_enabled', false);
    ?>
    <div class="wrap">
        <form method="post" action="">
			<h2>XML-RPC Manager</h2>
            <strong>This add-on <u>automatically disables XML-RPC</u></strong><br>
            We recommend keeping it disabled unless you need to use it for something specific, then you can enable it here.
            <br><br>
            <label>
                <input type="checkbox" name="xmlrpc_manager_enabled" <?php checked(1, $enabled); ?> value="1" />
                Enable XML-RPC functionality
            </label>
            <br><br>
            <input type="submit" class="button button-primary" value="Save Changes">
        </form> 
    </div>
    <?php
}

// Apply XML-RPC enable/disable based on settings
$enabled = get_option('xmlrpc_manager_enabled', false);
if (!$enabled) {
    add_filter('xmlrpc_enabled', '__return_false');
    remove_action('wp_head', 'rsd_link');
}
?>